## mingw-w64-paraview-5.13.1-2.src.tar.zst

=== Qt/Widgets/CMakeLists.txt ===
# SPDX-FileCopyrightText: Copyright (c) Kitware Inc.
# SPDX-FileCopyrightText: Copyright (c) Sandia Corporation
# SPDX-License-Identifier: BSD-3-Clause
set(classes
  pqCheckBoxPixMaps
  pqCheckBoxPixMaps
  pqCheckableHeaderView
  pqClickableLabel
  pqCollapsedGroup
  pqColorButtonEventPlayer
  pqColorButtonEventTranslator
  pqColorChooserButton
  pqColorDialogEventPlayer
  pqColorDialogEventTranslator
  pqConnect
  pqConsoleWidget
  pqConsoleWidgetEventPlayer
  pqConsoleWidgetEventTranslator
  pqDelimitedTextParser
  pqDiscreteDoubleWidget
  pqDoubleLineEdit
  pqDoubleRangeDialog
  pqDoubleRangeWidget
  pqDoubleSliderWidget
  pqDoubleSpinBox
  pqExpandableTableView
  pqExpanderButton
  pqExtendedSortFilterProxyModel
  pqFlatTreeView
  pqHeaderView
  pqHierarchicalGridLayout
  pqHierarchicalGridWidget
  pqHighlightablePushButton
  pqHighlightableToolButton
  pqLineEdit
  pqLineEditEventPlayer
  pqListWidgetCheckHelper
  pqListWidgetItemObject
  pqMultiColumnHeaderView
  pqProgressWidget
  pqQuickLaunchDialog
  pqScaleByButton
  pqScaledSpinBox
  pqScopedOverrideCursor
  pqSectionVisibilityContextMenu
  pqSeriesGeneratorDialog
  pqSetData
  pqSetName
  pqSignalAdaptors
  pqSpinBox
  pqTableView
  pqTextEdit
  pqTreeView
  pqTreeViewExpandState
  pqTreeViewSelectionHelper
  pqTreeWidget
  pqTreeWidgetCheckHelper
  pqTreeWidgetItem
  pqTreeWidgetItemObject
  pqTreeWidgetSelectionHelper
  pqVectorWidget
  pqWaitCursor
  pqWidgetCompleter
  pqWidgetsInit)

set(headers)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/pqQtWidgetsConfig.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/pqQtWidgetsConfig.h"
  @ONLY)
list(APPEND headers
  "${CMAKE_CURRENT_BINARY_DIR}/pqQtWidgetsConfig.h")

set(qt_components
  Core
  Gui
  Network
  Widgets)

if (APPLE)
  list(APPEND qt_components
    PrintSupport)
endif ()

if (PARAVIEW_QT_MAJOR_VERSION GREATER "5")
  list(APPEND qt_components
    Core5Compat)
endif ()

vtk_module_find_package(
  PACKAGE     "Qt${PARAVIEW_QT_MAJOR_VERSION}"
  COMPONENTS  ${qt_components})

##########################################################################
## Add *.ui files to be uic processed.
set(ui_files
  Resources/UI/pqExpanderButton.ui
  Resources/UI/pqQuickLaunchDialog.ui
  Resources/UI/pqSeriesGeneratorDialog.ui)

##########################################################################
## Add resources.
set(resource_files
  Resources/QtWidgets.qrc)

source_group("Resources" FILES
  ${ui_files}
  ${resource_files})

list(APPEND headers
  pqQtDeprecated.h
)

set(CMAKE_AUTOMOC 1)
set(CMAKE_AUTORCC 1)
set(CMAKE_AUTOUIC 1)
set(CMAKE_AUTOUIC_SEARCH_PATHS "${CMAKE_CURRENT_SOURCE_DIR}/Resources/UI")

set(translatable_files)
if (PARAVIEW_BUILD_TRANSLATIONS)
  list(APPEND translatable_files ${ui_files})
  foreach(el IN LISTS classes)
    list(APPEND translatable_files "${el}.cxx")
    list(APPEND translatable_files "${el}.h")
  endforeach()

  paraview_create_translation(
    TARGET "Widgets.ts"
    FILES ${translatable_files}
    OUTPUT_TS "${PARAVIEW_TRANSLATIONS_DIRECTORY}/Qt_Widgets.ts")
  add_dependencies(localization "Widgets.ts")
endif ()

vtk_module_add_module(ParaView::pqWidgets
  CLASSES ${classes}
  SOURCES ${ui_files}
          ${resource_files}
  HEADERS ${headers})
vtk_module_link(ParaView::pqWidgets
  PUBLIC
    "Qt${PARAVIEW_QT_MAJOR_VERSION}::Core"
    "Qt${PARAVIEW_QT_MAJOR_VERSION}::Gui"
    "Qt${PARAVIEW_QT_MAJOR_VERSION}::Widgets"
  PRIVATE
    "Qt${PARAVIEW_QT_MAJOR_VERSION}::Network")
vtk_module_definitions(ParaView::pqWidgets PRIVATE QT_NO_KEYWORDS)

if (PARAVIEW_QT_MAJOR_VERSION GREATER "5")
  vtk_module_link(ParaView::pqWidgets
    PRIVATE
      "Qt${PARAVIEW_QT_MAJOR_VERSION}::Core5Compat")
endif ()

if (APPLE)
  vtk_module_link(ParaView::pqWidgets
    PRIVATE
      "Qt${PARAVIEW_QT_MAJOR_VERSION}::PrintSupport")
endif ()

=== Remoting/Application/CMakeLists.txt ===
# SPDX-FileCopyrightText: Copyright (c) Kitware Inc.
# SPDX-FileCopyrightText: Copyright (c) Sandia Corporation
# SPDX-License-Identifier: BSD-3-Clause
set(classes
  vtkInitializationHelper)

set(private_headers
  vtkPVInitializer.h)

  set_source_files_properties(vtkInitializationHelper.cxx
  PROPERTIES
    COMPILE_DEFINITIONS "PARAVIEW_USE_PYTHON=$<BOOL:${PARAVIEW_USE_PYTHON}>")

vtk_module_add_module(ParaView::RemotingApplication
  CLASSES ${classes}
  PRIVATE_HEADERS ${private_headers})
vtk_module_link(ParaView::RemotingApplication
  PRIVATE
    paraview_client_server
    paraview_server_manager)
vtk_module_client_server_exclude()

set(xml_files
  Resources/extractors.xml
  Resources/internal_writers.xml
  Resources/utilities.xml)

function (_paraview_remoting_application_optional_xml)
  cmake_parse_arguments(PARSE_ARGV 0 _paraview_optional_xml
    ""
    ""
    "TARGETS;FILES")

  foreach (_paraview_optional_xml_target IN LISTS _paraview_optional_xml_TARGETS)
    _vtk_module_optional_dependency_exists("${_paraview_optional_xml_target}"
      SATISFIED_VAR _have_dep_module)
    if (NOT _have_dep_module)
      return ()
    endif ()
  endforeach ()

  set(xml_files "${xml_files}" ${_paraview_optional_xml_FILES} PARENT_SCOPE)
endfunction ()

_paraview_remoting_application_optional_xml(
  TARGETS VTK::CommonComputationalGeometry
  FILES   Resources/proxies_computationalgeometry.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::DomainsChemistry
  FILES   Resources/filters_domainschemistry.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::GeovisCore
  FILES   Resources/proxies_geoviscore.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOChemistry
  FILES   Resources/readers_iochemistry.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersAMR
  FILES   Resources/filters_filtersamr.xml
          Resources/sources_filtersamr.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersCellGrid
  FILES   Resources/filters_filterscellgrid.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersCore
  FILES   Resources/filters_filterscore.xml
          Resources/sources_filterscore.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersPoints
  FILES   Resources/filters_filterspoints.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersExtraction
  FILES   Resources/filters_filtersextraction.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersFlowPaths
  FILES   Resources/filters_filtersflowpaths.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersGeneral
  FILES   Resources/filters_filtersgeneral.xml
          Resources/sources_filtersgeneral.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersGeneral
          VTK::FiltersGeometry
          ParaView::VTKExtensionsFiltersGeneral
  FILES   Resources/filters_plotonintersectioncurves.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersGeneral
          VTK::FiltersParallel
          ParaView::VTKExtensionsFiltersGeneral
  FILES   Resources/filters_normalglyphs.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersGeneric
  FILES   Resources/filters_filtersgeneric.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersGeometry
  FILES   Resources/filters_filtersgeometry.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersParallel
  FILES   Resources/filters_filtersparallel.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersParallelMPI
  FILES   Resources/filters_filtersparallelmpi.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersHybrid
  FILES   Resources/filters_filtershybrid.xml
          Resources/readers_filtershybrid.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersHyperTree
  FILES   Resources/filters_filtershypertree.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersModeling
  FILES   Resources/filters_filtersmodeling.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersSources
  FILES   Resources/sources_filterssources.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersStatistics
  FILES   Resources/filters_filtersstatistics.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersTemporal
  FILES   Resources/filters_filterstemporal.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::ImagingCore
  FILES   Resources/filters_imagingcore.xml
          Resources/sources_imagingcore.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::ImagingFourier
  FILES   Resources/filters_imagingfourier.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::ImagingGeneral
  FILES   Resources/filters_imaginggeneral.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::ImagingHybrid
  FILES   Resources/filters_imaginghybrid.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::ImagingSources
  FILES   Resources/sources_imagingsources.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::ImagingStatistics
  FILES   Resources/filters_imagingstatistics.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersParallelDIY2
  FILES   Resources/filters_filtersparalleldiy2.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersParallelVerdict
  FILES   Resources/filters_filtersparallelverdict.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersTensor
  FILES   Resources/filters_filterstensors.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersTexture
  FILES   Resources/filters_filterstexture.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersVerdict
  FILES   Resources/filters_filtersverdict.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOCellGrid
  FILES   Resources/readers_iocellgrid.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOXML
          VTK::IOParallelXML
  FILES   Resources/readers_ioxml.xml
          Resources/writers_ioxml.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOAlembic
  FILES   Resources/proxies_alembic.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IONetCDF
  FILES   Resources/readers_ionetcdf.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOParallelNetCDF
  FILES   Resources/readers_ioparallelnetcdf.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOXdmf2
  FILES   Resources/proxies_xdmf2.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOXdmf3
  FILES   Resources/proxies_xdmf3.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOGDAL
  FILES   Resources/proxies_gdal.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOLAS
  FILES   Resources/proxies_las.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOPDAL
  FILES   Resources/proxies_pdal.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOCityGML
  FILES   Resources/proxies_citygml.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOCesium3DTiles
  FILES   Resources/proxies_cesium3dtiles.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOHDF
  FILES   Resources/readers_iohdf.xml
          Resources/writers_iohdf.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOERF
  FILES   Resources/readers_ioerf.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOSegY
  FILES   Resources/proxies_segy.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOADIOS2
  FILES   Resources/proxies_adios2_core.xml
          Resources/proxies_adios2_vtx.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOFides
  FILES   Resources/proxies_fides.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOOMF
  FILES   Resources/proxies_omf.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOMotionFX
  FILES   Resources/proxies_motionfx.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOLegacy
  FILES   Resources/writers_iolegacy.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOGeometry
  FILES   Resources/readers_iogeometry.xml
          Resources/writers_iogeometry.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOOCCT
  FILES   Resources/readers_ioocct.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOPLY
  FILES   Resources/readers_ioply.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOParallel
  FILES   Resources/readers_ioparallel.xml
          Resources/writers_ensight.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOParallelLSDyna
  FILES   Resources/readers_lsdyna.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOInfovis
  FILES   Resources/readers_ioinfovis.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOTecplotTable
  FILES   Resources/readers_iotecplottable.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOVPIC
  FILES   Resources/readers_iovpic.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOTRUCHAS
  FILES   Resources/readers_iotruchas.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOVeraOut
  FILES   Resources/readers_ioveraout.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOH5part
  FILES   Resources/readers_ioh5part.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOH5Rage
  FILES   Resources/readers_ioh5rage.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOPIO
  FILES   Resources/readers_iopio.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOCONVERGECFD
  FILES   Resources/readers_ioconvergecfd.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOCGNSReader
  FILES   Resources/readers_iocgns.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOFLUENTCFF
  FILES   Resources/readers_iofluentcff.xml)

_paraview_remoting_application_optional_xml(
  TARGETS ParaView::VTKExtensionsIOCGNSWriter
  FILES   Resources/writers_iocgns.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersOpenTURNS
  FILES   Resources/proxies_openturns.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::MomentInvariants
  FILES   Resources/MomentInvariants.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::ParallelMomentInvariants
  FILES   Resources/ParallelMomentInvariants.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::RenderingFreeType
  FILES   Resources/sources_renderingfreetype.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::InteractionWidgets
  FILES   Resources/proxies_interactionwidgets.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersParallel
          VTK::ImagingFourier
          ParaView::VTKExtensionsExtraction
  FILES   Resources/filters_selectionfftovertime.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOIOSS
  FILES   Resources/readers_ioioss.xml
          Resources/writers_ioioss.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOOpenVDB
  FILES   Resources/readers_ioopenvdb.xml
          Resources/writers_ioopenvdb.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOCatalystConduit
  FILES   Resources/proxies_conduit.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOFDS
  FILES   Resources/readers_iofds.xml)

_vtk_module_optional_dependency_exists(VTK::PythonInterpreter
  SATISFIED_VAR _have_vtk_pythoninterpreter)
if (TARGET _have_vtk_pythoninterpreter)
  _vtk_module_set_module_property(ParaView::RemotingApplication APPEND
    PROPERTY  "forward_link"
    VALUE     VTK::PythonUsed)
endif ()

=== VTKExtensions/FiltersGeneralMPI/CMakeLists.txt ===
# SPDX-FileCopyrightText: Copyright (c) Kitware Inc.
# SPDX-FileCopyrightText: Copyright (c) Sandia Corporation
# SPDX-License-Identifier: BSD-3-Clause
set(classes
  vtkInSituPParticlePathFilter
  vtkLegacyParticleTracerBase
  vtkLegacyPParticlePathFilter
  vtkLegacyPParticleTracerBase
  )

vtk_module_add_module(ParaView::VTKExtensionsFiltersGeneralMPI
  CLASSES ${classes})

paraview_add_server_manager_xmls(
  XMLS  Resources/general_mpi_filters.xml)

=== Clients/InSitu/catalyst/CMakeLists.txt ===
# XXX(catalyst-static): Catalyst does not implement the logic to build and
# import plugins statically yet. Force shared libraries for now.
set(BUILD_SHARED_LIBS ON)

if (WIN32)
  set(catalyst_library_destination
    "${_vtk_build_RUNTIME_DESTINATION}/catalyst")
else ()
  set(catalyst_library_destination
    "${_vtk_build_LIBRARY_DESTINATION}/catalyst")
  file(RELATIVE_PATH _catalyst_impl_relpath
    "/prefix/${catalyst_library_destination}"
    "/prefix/${_vtk_build_LIBRARY_DESTINATION}")
  if (APPLE)
    set(catalyst_rel_rpath
      "@loader_path/${_catalyst_impl_relpath}")
  else ()
    set(catalyst_rel_rpath
      "$ORIGIN/${_catalyst_impl_relpath}")
  endif ()

  list(APPEND CMAKE_INSTALL_RPATH
    "${catalyst_rel_rpath}")
endif ()

# setup this property so other place in the code can use catalyst (c.f. Examples)
set_property(GLOBAL PROPERTY paraview_catalyst_directory "${catalyst_library_destination}")

catalyst_implementation(
  NAME    paraview
  TARGET  catalyst-paraview
  LIBRARY_DESTINATION
    "${catalyst_library_destination}"
  SOURCES
    ParaViewCatalyst.cxx
    vtkCatalystBlueprint.cxx
    vtkCatalystBlueprint.h
  CATALYST_TARGET VTK::catalyst)
add_library(ParaView::catalyst-paraview ALIAS catalyst-paraview)

target_link_libraries(catalyst-paraview
  PRIVATE
    ParaView::InSitu
    ParaView::VTKExtensionsCore
    VTK::IOCatalystConduit
    ParaView::RemotingServerManager)

_vtk_module_optional_dependency_exists(VTK::ParallelMPI
  SATISFIED_VAR _have_vtk_parallelmpi)
_vtk_module_optional_dependency_exists(VTK::IOIOSS
  SATISFIED_VAR _have_vtk_ioioss)
_vtk_module_optional_dependency_exists(VTK::IOFides
  SATISFIED_VAR _have_vtk_iofides)

if (_have_vtk_parallelmpi)
  target_link_libraries(catalyst-paraview
    PRIVATE
      VTK::ParallelMPI)
endif ()

if (_have_vtk_ioioss)
  target_link_libraries(catalyst-paraview
    PRIVATE
      VTK::IOIOSS)
endif ()

if (_have_vtk_iofides)
  target_link_libraries(catalyst-paraview
    PRIVATE
      VTK::IOFides)
endif ()

target_compile_definitions(catalyst-paraview
  PRIVATE
    "VTK_MODULE_ENABLE_VTK_ParallelMPI=$<BOOL:${_have_vtk_parallelmpi}>"
    "VTK_MODULE_ENABLE_VTK_IOIOSS=$<BOOL:${_have_vtk_ioioss}>"
    "VTK_MODULE_ENABLE_VTK_IOFides=$<BOOL:${_have_vtk_iofides}>")

_vtk_module_optional_dependency_exists(VTK::Python
  SATISFIED_VAR _have_vtk_python)

if (_have_vtk_python)
  # Simulations loading the ParaView Catalyst implementation might not have
  # their own Python, so we need to ensure that it is brought in when loaded by
  # libcatalyst.
  set_property(TARGET catalyst-paraview
    PROPERTY
      INTERFACE_vtk_python_direct_link 1)
  target_link_libraries(catalyst-paraview
    PRIVATE
      VTK::PythonUsed)
endif ()

# Clear the `-pvVERSION` suffix (if any).
set(_vtk_build_LIBRARY_NAME_SUFFIX "")
# Clear version information.
set(_vtk_build_VERSION "")
set(_vtk_build_SOVERSION "")

_vtk_module_apply_properties(catalyst-paraview)

=== Examples/Catalyst/FortranPoissonSolver/CMakeLists.txt ===
set(sources
  Box.F90
  ConjugateGradient.F90
  FEDriver.F90
  PoissonDiscretization.F90
  SparseMatrix.F90)

if (USE_CATALYST)
  # We don't create a separate library for the adaptor here
  # since FEFortranAdaptor.F90 depends on Box.F90
  list(APPEND sources
    FECxxAdaptor.cxx
    FEFortranAdaptor.F90)
endif ()

add_executable(FortranPoissonSolver ${sources})
target_link_libraries(FortranPoissonSolver
  PRIVATE
    MPI::MPI_Fortran)
if (USE_CATALYST)
  target_link_libraries(FortranPoissonSolver
    PRIVATE
      ParaView::PythonCatalyst
      VTK::CommonDataModel
      VTK::ParallelMPI)
endif ()
set_property(TARGET FortranPoissonSolver
  PROPERTY
    LINKER_LANGUAGE Fortran)
set_property(TARGET FortranPoissonSolver
  PROPERTY
    POSITION_INDEPENDENT_CODE "${BUILD_SHARED_LIBS}")

if (BUILD_TESTING)
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/SampleScripts/coproc.py
    ${CMAKE_CURRENT_BINARY_DIR}/coproc.py
    COPYONLY)
  add_test(NAME FortranPoissonSolverTest COMMAND FortranPoissonSolver coproc.py)
endif()

=== Examples/Plugins/Autostart/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(Autostart)

find_package(ParaView REQUIRED)

option(BUILD_SHARED_LIBS "Build shared libraries" ON)
enable_testing()

include(GNUInstallDirs)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR}")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}")

set("_paraview_plugin_default_${PROJECT_NAME}" ON)
paraview_plugin_scan(
  PLUGIN_FILES      "${CMAKE_CURRENT_SOURCE_DIR}/Plugin/paraview.plugin"
  PROVIDES_PLUGINS  plugins
  REQUIRES_MODULES  required_modules)

foreach (module IN LISTS required_modules)
  if (NOT TARGET "${module}")
    message(#FATAL_ERROR
      "Skipping example ${PROJECT_NAME}: Missing required module: "
      "${module}")
    return ()
  endif ()
endforeach ()

paraview_plugin_build(
  RUNTIME_DESTINATION "${CMAKE_INSTALL_BINDIR}"
  LIBRARY_DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  LIBRARY_SUBDIRECTORY "${PARAVIEW_PLUGIN_SUBDIR}"
  PLUGINS ${plugins})

=== Plugins/AdiosReaderStaging/Staging/CMakeLists.txt ===
vtk_module_find_package(PACKAGE ADIOS1)

set(classes
  vtkCartisoReader)

vtk_module_add_module(AdiosReaderStaging::Staging
  CLASSES ${classes})

vtk_module_link(AdiosReaderStaging::Staging
  PRIVATE
    adios1::adios1)

paraview_add_server_manager_xmls(
  XMLS  AdiosReaderPixie.xml)

=== Plugins/GmshReader/Testing/CMakeLists.txt ===
if (BUILD_SHARED_LIBS)
  set(_paraview_add_tests_default_test_data_target ParaViewData)
  ExternalData_Expand_Arguments(ParaViewData _
    "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Gmsh/,REGEX:viz_.*}"
    "DATA{${CMAKE_CURRENT_SOURCE_DIR}/Data/Gmsh/naca0012/,REGEX:.*}")

  paraview_add_client_tests(
    LOAD_PLUGIN "GmshReader"
    BASELINE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline"
    TEST_DATA_TARGET ParaViewData
    TEST_SCRIPTS ${CMAKE_CURRENT_SOURCE_DIR}/GmshReaderTest.xml)

  paraview_add_client_server_tests(
    LOAD_PLUGIN "GmshReader"
    BASELINE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline"
    TEST_DATA_TARGET ParaViewData
    TEST_SCRIPTS ${CMAKE_CURRENT_SOURCE_DIR}/GmshReaderMeshOnlyTest.xml)
endif()

=== VTK/Documentation/docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXOPTS    ?= -T
SPHINXBUILD   ?= sphinx-build
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== VTK/Filters/General/CMakeLists.txt ===
set(classes
  vtkAnimateModes
  vtkAnnotationLink
  vtkAppendLocationAttributes
  vtkAppendPoints
  vtkApproximatingSubdivisionFilter
  vtkAreaContourSpectrumFilter
  vtkAxes
  vtkBlankStructuredGrid
  vtkBlankStructuredGridWithImage
  vtkBlockIdScalars
  vtkBooleanOperationPolyDataFilter
  vtkBoxClipDataSet
  vtkBrownianPoints
  vtkCellDerivatives
  vtkCellValidator
  vtkCleanUnstructuredGrid
  vtkCleanUnstructuredGridCells
  vtkClipClosedSurface
  vtkClipConvexPolyData
  vtkClipDataSet
  vtkClipVolume
  vtkCoincidentPoints
  vtkContourTriangulator
  vtkCountFaces
  vtkCountVertices
  vtkCursor2D
  vtkCursor3D
  vtkCurvatures
  vtkDataSetGradient
  vtkDataSetGradientPrecompute
  vtkDataSetTriangleFilter
  vtkDateToNumeric
  vtkDeflectNormals
  vtkDeformPointSet
  vtkDensifyPolyData
  vtkDicer
  vtkDiscreteFlyingEdges2D
  vtkDiscreteFlyingEdges3D
  vtkDiscreteFlyingEdgesClipper2D
  vtkDiscreteMarchingCubes
  vtkDistancePolyDataFilter
  vtkEdgePoints
  vtkEqualizerFilter
  vtkExtractArray
  vtkExtractGhostCells
  vtkExtractSelectedFrustum
  vtkExtractSelectionBase
  vtkFiniteElementFieldDistributor
  vtkGradientFilter
  vtkGraphLayoutFilter
  vtkGraphToPoints
  vtkGraphWeightEuclideanDistanceFilter
  vtkGraphWeightFilter
  vtkGroupDataSetsFilter
  vtkGroupTimeStepsFilter
  vtkHierarchicalDataLevelFilter
  vtkHyperStreamline
  vtkIconGlyphFilter
  vtkImageDataToPointSet
  vtkImageMarchingCubes
  vtkInterpolateDataSetAttributes
  vtkInterpolatingSubdivisionFilter
  vtkIntersectionPolyDataFilter
  vtkJoinTables
  vtkLevelIdScalars
  vtkLinkEdgels
  vtkLoopBooleanPolyDataFilter
  vtkMarchingContourFilter
  vtkMatricizeArray
  vtkMergeArrays
  vtkMergeCells
  vtkMergeTimeFilter
  vtkMergeVectorComponents
  vtkMultiBlockDataGroupFilter
  vtkMultiBlockMergeFilter
  vtkMultiThreshold
  vtkNormalizeMatrixVectors
  vtkOBBDicer
  vtkOBBTree
  vtkOverlappingAMRLevelIdScalars
  vtkPassArrays
  vtkPassSelectedArrays
  vtkPointConnectivityFilter
  vtkPolyDataStreamer
  vtkPolyDataToReebGraphFilter
  vtkProbePolyhedron
  vtkQuadraturePointInterpolator
  vtkQuadraturePointsGenerator
  vtkQuadratureSchemeDictionaryGenerator
  vtkQuantizePolyDataPoints
  vtkRandomAttributeGenerator
  vtkRectilinearGridClip
  vtkRectilinearGridToPointSet
  vtkRectilinearGridToTetrahedra
  vtkRecursiveDividingCubes
  vtkReflectionFilter
  vtkRemovePolyData
  vtkRotationFilter
  vtkSampleImplicitFunctionFilter
  vtkShrinkFilter
  vtkShrinkPolyData
  vtkSpatialRepresentationFilter
  vtkSpatioTemporalHarmonicsAttribute
  vtkSphericalHarmonics
  vtkSplineFilter
  vtkSplitByCellScalarFilter
  vtkSplitColumnComponents
  vtkSplitField
  vtkStructuredGridClip
  vtkSubPixelPositionEdgels
  vtkSubdivisionFilter
  vtkSynchronizeTimeFilter
  vtkTableBasedClipCases
  vtkTableBasedClipDataSet
  vtkTableFFT
  vtkTableToPolyData
  vtkTableToStructuredGrid
  vtkTemporalPathLineFilter
  vtkTemporalStatistics
  vtkTessellatorFilter
  vtkTimeSourceExample
  vtkTransformFilter
  vtkTransformPolyDataFilter
  vtkUncertaintyTubeFilter
  vtkVertexGlyphFilter
  vtkVolumeContourSpectrumFilter
  vtkVoxelContoursToSurfaceFilter
  vtkWarpLens
  vtkWarpScalar
  vtkWarpTo
  vtkWarpVector
  vtkYoungsMaterialInterface)

set(templates
  vtkJoinTables.txx)

vtk_module_add_module(VTK::FiltersGeneral
  CLASSES ${classes}
  TEMPLATES ${templates})
vtk_add_test_mangling(VTK::FiltersGeneral)

=== VTK/Filters/Parallel/CMakeLists.txt ===
set(classes
  vtkAdaptiveTemporalInterpolator
  vtkAggregateDataSetFilter
  vtkAlignImageDataSetFilter
  vtkAngularPeriodicFilter
  vtkCollectGraph
  vtkCollectPolyData
  vtkCollectTable
  vtkCutMaterial
  vtkDistributedDataFilter
  vtkDuplicatePolyData
  vtkExtractCTHPart
  vtkExtractPolyDataPiece
  vtkExtractUnstructuredGridPiece
  vtkExtractUserDefinedPiece
  vtkGenerateProcessIds
  vtkHyperTreeGridGenerateGlobalIds
  vtkHyperTreeGridGenerateProcessIds
  vtkHyperTreeGridGhostCellsGenerator
  vtkPHyperTreeGridProbeFilter
  vtkIntegrateAttributes
  vtkPeriodicFilter
  vtkPCellDataToPointData
  vtkPConvertToMultiBlockDataSet
  vtkPExtractDataArraysOverTime
  vtkPExtractExodusGlobalTemporalVariables
  vtkPExtractSelectedArraysOverTime
  vtkPieceRequestFilter
  vtkPieceScalars
  vtkPipelineSize
  vtkPKdTree
  vtkPLinearExtrusionFilter
  vtkPMaskPoints
  vtkPMergeArrays
  vtkPOutlineCornerFilter
  vtkPOutlineFilter
  vtkPOutlineFilterInternals
  vtkPPolyDataNormals
  vtkPProbeFilter
  vtkPProjectSphereFilter
  vtkPReflectionFilter
  vtkPResampleFilter
  vtkPartitionBalancer
  vtkProcessIdScalars
  vtkPSphereSource
  vtkPTextureMapToSphere
  vtkPYoungsMaterialInterface
  vtkRectilinearGridOutlineFilter
  vtkRemoveGhosts
  vtkTransmitPolyDataPiece
  vtkTransmitRectilinearGridPiece
  vtkTransmitStructuredDataPiece
  vtkTransmitStructuredGridPiece
  vtkTransmitUnstructuredGridPiece)

set(headers
  vtkBlockDistribution.h)

set(sources
  vtkHyperTreeGridGhostCellsGeneratorInternals.cxx)

set(private_headers
  vtkHyperTreeGridGhostCellsGeneratorInternals.h)


vtk_object_factory_declare(
  BASE vtkConvertToMultiBlockDataSet
  OVERRIDE vtkPConvertToMultiBlockDataSet
  )

vtk_object_factory_configure(
  SOURCE_FILE vtk_object_factory_source
  HEADER_FILE vtk_object_factory_header
  EXPORT_MACRO "VTKFILTERSPARALLEL_EXPORT"
  )

vtk_module_add_module(VTK::FiltersParallel
  CLASSES ${classes}
  HEADERS ${headers}
  SOURCES ${vtk_object_factory_source} ${sources}
  PRIVATE_HEADERS ${vtk_object_factory_header} ${private_headers}
  )
vtk_add_test_mangling(VTK::FiltersParallel)

=== VTK/IO/ERF/CMakeLists.txt ===
set(classes
  vtkHDF5Helper
  vtkERFReader)

vtk_module_add_module(VTK::IOERF
  CLASSES ${classes}
  )
vtk_add_test_mangling(VTK::IOERF)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=paraview
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=5.13.1
pkgrel=2
pkgdesc="Parallel Data Analysis and Visualization Application based on VTK. (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.paraview.org/'
msys2_repository_url="https://gitlab.kitware.com/paraview/paraview"
msys2_references=(
  'archlinux: paraview'
)
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-double-conversion"
         "${MINGW_PACKAGE_PREFIX}-cgns"
         "${MINGW_PACKAGE_PREFIX}-expat"
         "${MINGW_PACKAGE_PREFIX}-fmt"
         "${MINGW_PACKAGE_PREFIX}-gdal"
         "${MINGW_PACKAGE_PREFIX}-gl2ps"
         "${MINGW_PACKAGE_PREFIX}-glew"
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-jsoncpp"
         "${MINGW_PACKAGE_PREFIX}-libjpeg-turbo"
         "${MINGW_PACKAGE_PREFIX}-libogg"
         "${MINGW_PACKAGE_PREFIX}-liblas"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libtheora"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         "${MINGW_PACKAGE_PREFIX}-lz4"
         "${MINGW_PACKAGE_PREFIX}-netcdf"
         "${MINGW_PACKAGE_PREFIX}-openturns"
         "${MINGW_PACKAGE_PREFIX}-pdal"
         #"${MINGW_PACKAGE_PREFIX}-pegtl" https://gitlab.kitware.com/vtk/vtk/-/issues/18151
         "${MINGW_PACKAGE_PREFIX}-protobuf"
         "${MINGW_PACKAGE_PREFIX}-python"
         "${MINGW_PACKAGE_PREFIX}-pugixml"
         "${MINGW_PACKAGE_PREFIX}-qt5-base"
         "${MINGW_PACKAGE_PREFIX}-qt5-svg"
         "${MINGW_PACKAGE_PREFIX}-qt5-tools"
         "${MINGW_PACKAGE_PREFIX}-tbb"
         $([[ ${MSYSTEM} == MINGW64 ]] || echo "${MINGW_PACKAGE_PREFIX}-verdict")
         "${MINGW_PACKAGE_PREFIX}-xz"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread-git"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-qt5-xmlpatterns"
             "${MINGW_PACKAGE_PREFIX}-python-numpy"
             "${MINGW_PACKAGE_PREFIX}-cli11"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-fast_float"
             "${MINGW_PACKAGE_PREFIX}-libharu"
             "${MINGW_PACKAGE_PREFIX}-nlohmann-json"
             "${MINGW_PACKAGE_PREFIX}-utf8cpp")
optdepends=("${MINGW_PACKAGE_PREFIX}-python-numpy"
            "${MINGW_PACKAGE_PREFIX}-python-matplotlib")
source=("https://www.paraview.org/files/v${pkgver%.*}/ParaView-v${pkgver}.tar.xz"
        "001-dll-export-some-vtk-functions.patch"
        "002-no-exact-version-for-fast_float.patch"
        "003-CellAttribute-Fix-mingw-build.patch::https://gitlab.kitware.com/vtk/vtk/-/commit/5a7de249.patch"
        "004-fix-build-with-fmt-11.patch")
sha256sums=('a16503ce37b999c2967d84234596e7bf67ac98221851a288bb1399c7e1dc2004'
            'a9b9292be90c259f0aa058e3f4a7a08b6218f20e6cb2a71e214acda2d2302a50'
            '411b0521fcd2864acae0af20ba6334f69f7c605c9e31996529f64aa749d61065'
            '784d9345ebb1a83841970df34d743344189604457270df0f594669639a718ec8'
            'c92343b01c50a93805c7068058416cf010cceba6700e4cc16b3be98598d2295f')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}"/ParaView-v${pkgver}

  cd VTK
  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    # Copied from mingw-w64-vtk/007-dll-export-some-functions.patch
    apply_patch_with_msg \
      001-dll-export-some-vtk-functions.patch
  fi

  apply_patch_with_msg \
    002-no-exact-version-for-fast_float.patch \
    003-CellAttribute-Fix-mingw-build.patch \
    004-fix-build-with-fmt-11.patch
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MSYSTEM} == MINGW64 ]]; then
    _extra_config+=("-DVTK_MODULE_USE_EXTERNAL_VTK_verdict=OFF")
  fi

  _pyver=$(${MINGW_PREFIX}/bin/python -c "import sys; print(f'{sys.version_info.major}.{sys.version_info.minor}')")

  CXXFLAGS+=" -w -Wno-register" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DPARAVIEW_BUILD_SHARED_LIBS=ON \
      -DPARAVIEW_USE_PYTHON=ON \
      -DPARAVIEW_USE_QT=ON \
      -DPARAVIEW_USE_MPI=OFF \
      -DPARAVIEW_ENABLE_GDAL=ON \
      -DPARAVIEW_ENABLE_LAS=ON \
      -DPARAVIEW_ENABLE_OPENTURNS=ON \
      -DPARAVIEW_ENABLE_PDAL=ON \
      -DPARAVIEW_VERSIONED_INSTALL=OFF \
      -DPARAVIEW_CUSTOM_LIBRARY_SUFFIX="pv${pkgver%.*}" \
      -DPARAVIEW_BUILD_WITH_EXTERNAL=ON \
      -DPARAVIEW_PYTHON_SITE_PACKAGES_SUFFIX="lib/python${_pyver}/site-packages/pv/" \
      -DPARAVIEW_IGNORE_CMAKE_CXX11_CHECKS=ON \
      -DVTK_SMP_IMPLEMENTATION_TYPE=TBB \
      -DVTK_MODULE_USE_EXTERNAL_VTK_exprtk=OFF \
      -DVTK_MODULE_USE_EXTERNAL_VTK_ioss=OFF \
      -DVTK_MODULE_USE_EXTERNAL_VTK_pegtl=OFF \
      -DVTK_MODULE_USE_EXTERNAL_VTK_token=OFF \
      -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python.exe \
      ../ParaView-v${pkgver}

  "${MINGW_PREFIX}"/bin/cmake.exe --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .

  MSYS2_ARG_CONV_EXCL="-p" python -m compileall \
    -o 0 -o 1 -q -s"${pkgdir}" -p"/" "${pkgdir}${MINGW_PREFIX}/lib/python"*

  install -Dm644 "${srcdir}/ParaView-v${pkgver}/Copyright.txt" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
